/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the OrganizationMutableValidationCenterSettings type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &OrganizationMutableValidationCenterSettings{}

// OrganizationMutableValidationCenterSettings switches on/off
type OrganizationMutableValidationCenterSettings struct {
	InteractionSettings *OrganizationMutableValidationCenterSettingsInteractionSettings `json:"interaction_settings,omitempty"`
}

// NewOrganizationMutableValidationCenterSettings instantiates a new OrganizationMutableValidationCenterSettings object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewOrganizationMutableValidationCenterSettings() *OrganizationMutableValidationCenterSettings {
	this := OrganizationMutableValidationCenterSettings{}
	return &this
}

// NewOrganizationMutableValidationCenterSettingsWithDefaults instantiates a new OrganizationMutableValidationCenterSettings object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewOrganizationMutableValidationCenterSettingsWithDefaults() *OrganizationMutableValidationCenterSettings {
	this := OrganizationMutableValidationCenterSettings{}
	return &this
}

// GetInteractionSettings returns the InteractionSettings field value if set, zero value otherwise.
func (o *OrganizationMutableValidationCenterSettings) GetInteractionSettings() OrganizationMutableValidationCenterSettingsInteractionSettings {
	if o == nil || IsNil(o.InteractionSettings) {
		var ret OrganizationMutableValidationCenterSettingsInteractionSettings
		return ret
	}
	return *o.InteractionSettings
}

// GetInteractionSettingsOk returns a tuple with the InteractionSettings field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationMutableValidationCenterSettings) GetInteractionSettingsOk() (*OrganizationMutableValidationCenterSettingsInteractionSettings, bool) {
	if o == nil || IsNil(o.InteractionSettings) {
		return nil, false
	}
	return o.InteractionSettings, true
}

// HasInteractionSettings returns a boolean if a field has been set.
func (o *OrganizationMutableValidationCenterSettings) HasInteractionSettings() bool {
	if o != nil && !IsNil(o.InteractionSettings) {
		return true
	}

	return false
}

// SetInteractionSettings gets a reference to the given OrganizationMutableValidationCenterSettingsInteractionSettings and assigns it to the InteractionSettings field.
func (o *OrganizationMutableValidationCenterSettings) SetInteractionSettings(v OrganizationMutableValidationCenterSettingsInteractionSettings) {
	o.InteractionSettings = &v
}

func (o OrganizationMutableValidationCenterSettings) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o OrganizationMutableValidationCenterSettings) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.InteractionSettings) {
		toSerialize["interaction_settings"] = o.InteractionSettings
	}
	return toSerialize, nil
}

type NullableOrganizationMutableValidationCenterSettings struct {
	value *OrganizationMutableValidationCenterSettings
	isSet bool
}

func (v NullableOrganizationMutableValidationCenterSettings) Get() *OrganizationMutableValidationCenterSettings {
	return v.value
}

func (v *NullableOrganizationMutableValidationCenterSettings) Set(val *OrganizationMutableValidationCenterSettings) {
	v.value = val
	v.isSet = true
}

func (v NullableOrganizationMutableValidationCenterSettings) IsSet() bool {
	return v.isSet
}

func (v *NullableOrganizationMutableValidationCenterSettings) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableOrganizationMutableValidationCenterSettings(val *OrganizationMutableValidationCenterSettings) *NullableOrganizationMutableValidationCenterSettings {
	return &NullableOrganizationMutableValidationCenterSettings{value: val, isSet: true}
}

func (v NullableOrganizationMutableValidationCenterSettings) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableOrganizationMutableValidationCenterSettings) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


